/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/rx/rx.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 54 "../../gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 60 "../../gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 69 "../../gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 71 "../../gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 78 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 79 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 85 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 86 "../../gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 90 "../../gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 94 "../../gcc/common.md"
(CONSTANT_P (op))) && (
#line 95 "../../gcc/common.md"
(!flag_pic || raw_constraint_p || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 99 "../../gcc/common.md"
(CONSTANT_P (op))) && ((
#line 100 "../../gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 101 "../../gcc/common.md"
(!flag_pic || raw_constraint_p || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint__c (rtx op)
{
  return (
#line 105 "../../gcc/common.md"
(CONSTANT_P (op))) && (
#line 106 "../../gcc/common.md"
(!CONST_SCALAR_INT_P (op)));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 110 "../../gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 111 "../../gcc/common.md"
(!flag_pic || raw_constraint_p || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 115 "../../gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 116 "../../gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 122 "../../gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 123 "../../gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 128 "../../gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_Symbol (rtx op)
{
  return 
#line 24 "../../gcc/config/rx/constraints.md"
(GET_CODE (op) == SYMBOL_REF);
}
static inline bool
satisfies_constraint_Int08 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 31 "../../gcc/config/rx/constraints.md"
(IN_RANGE (ival, (HOST_WIDE_INT_M1U << 8), (1 << 8) - 1)));
}
static inline bool
satisfies_constraint_Sint08 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 38 "../../gcc/config/rx/constraints.md"
(IN_RANGE (ival, (HOST_WIDE_INT_M1U << 7), (1 << 7) - 1)));
}
static inline bool
satisfies_constraint_Sint16 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 45 "../../gcc/config/rx/constraints.md"
(IN_RANGE (ival, (HOST_WIDE_INT_M1U << 15), (1 << 15) - 1)));
}
static inline bool
satisfies_constraint_Sint24 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 52 "../../gcc/config/rx/constraints.md"
(IN_RANGE (ival, (HOST_WIDE_INT_M1U << 23), (1 << 23) - 1)));
}
static inline bool
satisfies_constraint_Uint04 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 62 "../../gcc/config/rx/constraints.md"
(IN_RANGE (ival, 0, 15)));
}
static inline bool
satisfies_constraint_NEGint4 (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 69 "../../gcc/config/rx/constraints.md"
(IN_RANGE (ival, -15, -1)));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == REG) || ((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG || GET_CODE (XEXP (XEXP (op, 0), 0)) == SUBREG) && ((GET_CODE (XEXP (XEXP (op, 0), 1)) == CONST_INT) && (
#line 84 "../../gcc/config/rx/constraints.md"
(rx_is_restricted_memory_address (XEXP (op, 0), mode)))))));
}
static inline bool
satisfies_constraint_Rpid (rtx op)
{
  return (GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == PLUS) && ((GET_CODE (XEXP (XEXP (op, 0), 0)) == REG || GET_CODE (XEXP (XEXP (op, 0), 0)) == SUBREG) && (GET_CODE (XEXP (XEXP (op, 0), 1)) == UNSPEC)));
}
static inline bool
satisfies_constraint_Rpda (rtx op)
{
  return (GET_CODE (op) == PLUS) && ((GET_CODE (XEXP (op, 0)) == REG || GET_CODE (XEXP (op, 0)) == SUBREG) && (GET_CODE (XEXP (op, 1)) == UNSPEC));
}
static inline bool
satisfies_constraint_CALL__OP__SYMBOL__REF (rtx op)
{
  return (
#line 113 "../../gcc/config/rx/constraints.md"
(!TARGET_JSR)) && (GET_CODE (op) == SYMBOL_REF);
}
#endif /* tm-constrs.h */
